package com.bonus.material.settlement.mapper;

import java.util.List;

import com.bonus.common.biz.domain.ProjectTreeNode;
import com.bonus.common.biz.domain.lease.LeaseOutDetails;
import com.bonus.material.common.domain.vo.AgreementVo;
import com.bonus.material.ma.domain.Type;
import com.bonus.material.repair.domain.RepairApplyDetails;
import com.bonus.material.settlement.domain.SltAgreementApply;
import com.bonus.material.settlement.domain.SltAgreementInfo;
import com.bonus.material.settlement.domain.SltAgreementRelation;
import com.bonus.material.settlement.domain.vo.SltInfoVo;
import com.bonus.material.task.domain.TmTask;
import org.apache.ibatis.annotations.Param;

/**
 * 结算信息Mapper接口
 * 
 * @author xsheng
 * @date 2024-10-16
 */
public interface SltAgreementInfoMapper {
    /**
     * 查询结算信息
     * 
     * @param id 结算信息主键
     * @return 结算信息
     */
    public SltAgreementInfo selectSltAgreementInfoById(Long id);

    /**
     * 查询结算信息列表
     * 
     * @param sltAgreementInfo 结算信息
     * @return 结算信息集合
     */
    public List<SltAgreementInfo> selectSltAgreementInfoList(SltAgreementInfo sltAgreementInfo);

    /**
     * 新增结算信息
     * 
     * @param sltAgreementInfo 结算信息
     * @return 结果
     */
    public int insertSltAgreementInfo(SltAgreementInfo sltAgreementInfo);

    /**
     * 修改结算信息
     * 
     * @param sltAgreementInfo 结算信息
     * @return 结果
     */
    public int updateSltAgreementInfo(SltAgreementInfo sltAgreementInfo);

    /**
     * 删除结算信息
     * 
     * @param id 结算信息主键
     * @return 结果
     */
    public int deleteSltAgreementInfoById(Long id);

    /**
     * 批量删除结算信息
     * 
     * @param ids 需要删除的数据主键集合
     * @return 结果
     */
    public int deleteSltAgreementInfoByIds(Long[] ids);

    SltAgreementInfo getSltAgreementInfo(LeaseOutDetails record);

    List<SltAgreementInfo> getSltAgreementInfo4Project(SltAgreementInfo record);

    List<SltAgreementApply> getSltExam(SltAgreementInfo bean);

    String getCost(SltAgreementApply apply);

    List<SltAgreementRelation> getRelations(SltAgreementApply apply);

    int updSltInfo(SltAgreementInfo sltAgreementInfo);

    int insSltInfo(@Param("record") LeaseOutDetails record, @Param("agreementId")String agreementId, @Param("ma") Type ma);

    List<SltAgreementInfo> getLeaseList(SltAgreementInfo bean);

    List<SltAgreementInfo> getRepairDetailsList(@Param("taskList") List<TmTask> taskList);

    List<SltAgreementInfo> getScrapDetailsList(@Param("taskList") List<TmTask> taskList);

    List<SltAgreementInfo> getLoseList(SltAgreementInfo bean);

    int updateRelation(SltAgreementApply apply);

    int updateApply(SltAgreementApply apply);

    int updateMaStatus(SltAgreementInfo agreementInfo);

    /**
     * 退料驳回结算信息处理
     */
    int backRejectSltCope(Long backTaskId);

    /**
     * 退料结算信息删除
     * @param leaseOutDetails
     * @return
     */
    int deleteSltInfo(@Param("record") LeaseOutDetails leaseOutDetails);

    /**
     * 查找是否驳回
     *
     * @param sltInfoVo 结算信息
     * @return 结果
     */
    public int getRejectCount(SltInfoVo sltInfoVo);

    /**
     * 新增结算审核信息
     *
     * @param sltInfoVo 结算信息
     * @return 结果
     */
    public int insertSltAgreementApply(SltInfoVo sltInfoVo);

    /**
     * 修改结算审核信息
     *
     * @param sltInfoVo 结算信息
     * @return 结果
     */
    public int updateBmAgreementStatus(SltInfoVo sltInfoVo);

    /**
     * 新增租赁结算明细
     * @param list
     * @param id
     * @return
     */
    int insertSltAgreementDetailLease(@Param("list") List<SltAgreementInfo> list,@Param("id") Long id);

    /**
     * 新增维修结算明细
     * @param list
     * @param id
     * @return
     */
    int insertSltAgreementDetailRepair(@Param("list") List<SltAgreementInfo> list,@Param("id") Long id);

    /**
     * 新增报废结算明细
     * @param list
     * @param id
     * @return
     */
    int insertSltAgreementDetailScrap(@Param("list") List<SltAgreementInfo> list,@Param("id") Long id);

    /**
     * 新增丢失结算明细
     * @param list
     * @param id
     * @return
     */
    int insertSltAgreementDetailLose(@Param("list") List<SltAgreementInfo> list,@Param("id") Long id);

    /**
     * 结算审批列表
     *
     * @param bean 结算信息
     * @return 结果
     */
    List<SltAgreementInfo> getSltList(SltAgreementInfo bean);

    /**
     * 对驳回的结算信息进行重新设置为未结算
     *
     * @param sltInfoVo 结算信息
     * @return 结果
     */
    int updateRejectCount(SltInfoVo sltInfoVo);

    /**
     * 获取对驳回的结算信息的id
     *
     * @param sltInfoVo 结算信息
     * @return 结果
     */
    Long getRejectId(SltInfoVo sltInfoVo);

    /**
     * 进行结算审批
     *
     * @param sltAgreementApply 进行结算审批
     * @return 结果
     */
    int costExame(SltAgreementApply sltAgreementApply);

    void costDeleteDetail(SltAgreementApply sltAgreementApply);

    /**
     * 审核驳回时修改是否结算
     *
     * @param sltAgreementApply 结算信息
     * @return 结果
     */
    public int updateBmAgreementReject(SltAgreementApply sltAgreementApply);

    int[] getProjectListByUnitIds(int unitId);

    List<ProjectTreeNode> getProjectList(int projectId);

    List<AgreementVo> getAgreementInfoById(@Param("unitIds") List<Integer> unitIds, @Param("projectId") int projectId);

    int backInUseNum(RepairApplyDetails repairApplyDetails);

}
